Attribute VB_Name = "modProcedimientos"
Option Explicit

Public Sub LeerArchivoINI()
'Lee los datos de inicializacin, del archivo "nFotos1palabra.ini"
On Error GoTo ErrorEnLeerArchivoIni
Dim intNumArch As Integer, strCadenaLeida As String, strAux1 As String, strAux2 As String
intNumArch = FreeFile
Open App.Path & "\nFotos1palabra.ini" For Input As intNumArch
Input #intNumArch, strCadenaLeida 'Lee el nombre y versin del programa
Input #intNumArch, strCadenaLeida 'Lee strConfiguracion
SepararPorDosPuntos strCadenaLeida, strAux1, strConfiguracion
If (strConfiguracion = "Ninguno") Then
  strConfiguracion = App.Path & "\4fotos\Ejemplo_4_fotos.nf1p"
End If
If (strConfiguracion = NombreDeArchivo(strConfiguracion)) Then
  'strConfiguracion no tiene path, por lo tanto le agrega el del programa
  strConfiguracion = App.Path & "\" & strConfiguracion
End If

Input #intNumArch, strCadenaLeida 'Lee blnAvanzarAutomticamente
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnAvanzarAutomticamente = strAux2
Input #intNumArch, strCadenaLeida 'Lee blnOrdenAleatorio
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnOrdenAleatorio = strAux2
Input #intNumArch, strCadenaLeida 'Lee blnActivarBarrido
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnActivarBarrido = strAux2
Input #intNumArch, strCadenaLeida 'Lee intIntervaloDeBarrido
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
intIntervaloDeBarrido = Val(strAux2)

Close intNumArch
Exit Sub

CargaPorDefectoArchivoINI:
'Establece valores iniciales por defecto (ya que no se encontr nFotos1palabra.ini)
MsgBox "No se encontr el archivo de inicializacin, por lo que se utilizarn valores por defecto", vbOKOnly + vbExclamation, "Atencin"
strConfiguracion = "Nuevo"
blnAvanzarAutomticamente = False
blnOrdenAleatorio = False
blnActivarBarrido = False
intIntervaloDeBarrido = 10
Close intNumArch
Exit Sub

ErrorEnLeerArchivoIni:
  Select Case Err.Number
    Case 53 'No existe el archivo .ini
      Resume CargaPorDefectoArchivoINI
    Case 62 'El archivo .ini tiene menos lneas que las necesarias
      Resume CargaPorDefectoArchivoINI
    Case Else
      Resume CargaPorDefectoArchivoINI
  End Select
End Sub


Public Sub GuardarArchivoINI()
'Guarda los datos de inicializacin, en "nFotos1palabra.ini"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intNumArch As Integer

intNumArch = FreeFile
Open App.Path & "\nFotos1palabra.ini" For Output As intNumArch
Write #intNumArch, "N fotos y una palabra, versin: " & App.Major & "." & App.Minor
Write #intNumArch, "ltimo archivo abierto: " & strConfiguracion
Write #intNumArch, "Avanzar automticamente: " & blnAvanzarAutomticamente
Write #intNumArch, "Orden aleatorio: " & blnOrdenAleatorio
Write #intNumArch, "Activar barrido: " & blnActivarBarrido
Write #intNumArch, "Intervalo de barrido: " & intIntervaloDeBarrido
Close intNumArch
End Sub


Public Sub LeerConfiguracion(strArchivo As String)
'Lee los datos del archivo de configuracin .nf1p "strArchivo"
On Error GoTo ErrorEnLeerConfiguracion
Dim intNumArch As Integer, strCadenaLeida As String, strAux1 As String, strAux2 As String
Dim intAux1, intAux2 As Integer

intNumArch = FreeFile
Open strArchivo For Input As intNumArch
LeerDato intNumArch, strCadenaLeida
SepararPorDosPuntos strCadenaLeida, strAux1, strVersinArchivo
LeerDato intNumArch, strCadenaLeida
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
lngColorDelFondo = Val(strAux2)
LeerDato intNumArch, strCadenaLeida
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
intCantidadDeFotos = Val(strAux2)
LeerDato intNumArch, strCadenaLeida
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
intCantidadDePalabras = Val(strAux2)
For intAux1 = 1 To intCantidadDePalabras
  For intAux2 = 1 To intCantidadDeFotos
    LeerDato intNumArch, strCadenaLeida
    SepararPorDosPuntos strCadenaLeida, strAux1, strFoto(intAux1, intAux2)
  Next intAux2
  LeerDato intNumArch, strCadenaLeida
  SepararPorDosPuntos strCadenaLeida, strAux1, strPalabra(intAux1)
  LeerDato intNumArch, strCadenaLeida
  SepararPorDosPuntos strCadenaLeida, strAux1, strLetras(intAux1)
Next intAux1

Close intNumArch
Exit Sub

CargaPorDefectoConfiguracin:
'Establece valores por defecto
strConfiguracion = "Ninguno"  'Antes pona  App.Path & "\Sin ttulo.nf1p"  pero "Ninguno" permite armar un instalador para que la primera vez que se ejecute encuentre el Ejemplo sin importar en qu carpeta est
lngColorDelFondo = &HFFFFFF
intCantidadDeFotos = 4
intCantidadDePalabras = 2
Erase strFoto
Erase strPalabra
Erase strLetras
Close intNumArch
Exit Sub

ErrorEnLeerConfiguracion:
  Select Case Err.Number
    Case 53, 76 'No existe el archivo
      Resume CargaPorDefectoConfiguracin
    Case 62 'El archivo tiene menos lneas que las necesarias
      Resume CargaPorDefectoConfiguracin
    Case Else
      Resume CargaPorDefectoConfiguracin
  End Select
End Sub


Public Sub GuardarConfiguracion(strArchivo As String)
'Guarda los datos de configuracin en el archivo .nf1p "strArchivo"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intNumArch, intAux1, intAux2 As Integer

intNumArch = FreeFile
Open strArchivo For Output As intNumArch
Write #intNumArch, "N fotos y una palabra, versin: " & App.Major & "." & App.Minor
Write #intNumArch, "Color del fondo: " & lngColorDelFondo
Write #intNumArch, "Cantidad de fotos por palabra: " & intCantidadDeFotos
Write #intNumArch, "Cantidad de palabras: " & intCantidadDePalabras
Write #intNumArch, ""
For intAux1 = 1 To intCantidadDePalabras
  For intAux2 = 1 To intCantidadDeFotos
    Write #intNumArch, "Foto " & intAux1 & ", " & intAux2 & ": " & strFoto(intAux1, intAux2)
  Next intAux2
  Write #intNumArch, "Palabra " & intAux1 & ": " & strPalabra(intAux1)
  Write #intNumArch, "Letras para palabra " & intAux1 & ": " & strLetras(intAux1)
  Write #intNumArch, ""
Next intAux1
Close intNumArch
End Sub


Public Sub LeerDato(intArch As Integer, ByRef strCadena As String)
'Lee del archivo intArch "strCadena", siempre que no sea nula
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Input #intArch, strCadena
Do While (strCadena = "")
  Input #intArch, strCadena
Loop
End Sub


Public Sub SepararPorDosPuntos(strCadena As String, ByRef strPrimeraParte As String, ByRef strSegundaParte As String)
'Devuelve la primera parte de "strCadena", hasta los ":", en "strPrimeraParte", y lo siguiente en "strSegundaParte"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intPos As Integer
intPos = InStr(strCadena, ":")
If (intPos > 0) Then
  strPrimeraParte = Mid(strCadena, 1, intPos - 1)
  strSegundaParte = Mid(strCadena, intPos + 1, Len(strCadena) - intPos)
  strSegundaParte = Trim(strSegundaParte)
Else
  strPrimeraParte = ""
  strSegundaParte = ""
End If
End Sub


Public Sub ActualizarPantallaSegunValores()
'Modifica lo que aparece en el formulario Principal de acuerdo a los valores de las variables
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)

Dim intAux As Integer

frmPrincipal.fraArchivo.Caption = " " & NombreDeArchivo(strConfiguracion) & " "
frmPrincipal.lblColorFondo.BackColor = lngColorDelFondo
frmPrincipal.txtCantidadDeFotosPorPalabra.Text = intCantidadDeFotos
frmPrincipal.txtCantidadDePalabras.Text = intCantidadDePalabras
frmPrincipal.cboPalabra.Clear
For intAux = 1 To intCantidadDePalabras
  frmPrincipal.cboPalabra.AddItem (intAux)
Next intAux
frmPrincipal.cboPalabra.ListIndex = 0
frmPrincipal.txtPalabra.Text = strPalabra(1)
frmPrincipal.txtLetras.Text = strLetras(1)
frmPrincipal.cboImagen.Clear
For intAux = 1 To intCantidadDeFotos
  frmPrincipal.cboImagen.AddItem (intAux)
Next intAux
frmPrincipal.cboImagen.ListIndex = 0
frmPrincipal.txtImagen.Text = strFoto(1, 1)

ChequearEdicin

If (blnAvanzarAutomticamente = True) Then
  frmPrincipal.chkAvanzar.Value = 1
Else
  frmPrincipal.chkAvanzar.Value = 0
End If
  blnAuxOrdenAleatorioNoDisponible = True 'Esta variable se usa slo hasta implementar la opcin de Orden Aleatorio (para que no aparezcla la aclaracin al iniciar el programa)
If (blnOrdenAleatorio = True) Then
  frmPrincipal.chkOrdenAleatorio.Value = 1
Else
  frmPrincipal.chkOrdenAleatorio.Value = 0
End If
  blnAuxOrdenAleatorioNoDisponible = False 'Esta variable se usa slo hasta implementar la opcin de Orden Aleatorio (para que no aparezcla la aclaracin al iniciar el programa)
If (blnActivarBarrido = True) Then
  frmPrincipal.chkActivarBarrido.Value = 1
Else
  frmPrincipal.chkActivarBarrido.Value = 0
End If
If (blnActivarBarrido = True) Then
  frmPrincipal.lblIntervaloDeBarrido.Enabled = True
  frmPrincipal.txtIntervaloDeBarrido.Enabled = True
Else
  frmPrincipal.lblIntervaloDeBarrido.Enabled = False
  frmPrincipal.txtIntervaloDeBarrido.Enabled = False
End If
frmPrincipal.txtIntervaloDeBarrido.Text = intIntervaloDeBarrido
End Sub


Public Sub ChequearEdicin()
'Modifica los controles editables segn el valor de blnEditando
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)

If (blnEditando = True) Then
  frmPrincipal.cmdAbrir.Enabled = False
  frmPrincipal.cmdNuevo.Enabled = False
  frmPrincipal.lblColorFondo.Enabled = True
  frmPrincipal.txtCantidadDeFotosPorPalabra.Locked = False
  frmPrincipal.txtCantidadDeFotosPorPalabra.BackColor = &H80000005
  frmPrincipal.txtCantidadDePalabras.Locked = False
  frmPrincipal.txtCantidadDePalabras.BackColor = &H80000005
  frmPrincipal.txtPalabra.Locked = False
  frmPrincipal.txtPalabra.PasswordChar = ""
  frmPrincipal.txtPalabra.BackColor = &H80000005
  frmPrincipal.txtLetras.Locked = False
  frmPrincipal.txtLetras.BackColor = &H80000005
  frmPrincipal.txtImagen.BackColor = &H80000005
  frmPrincipal.cmdEjecutar.Default = False
Else
  frmPrincipal.cmdAbrir.Enabled = True
  frmPrincipal.cmdNuevo.Enabled = True
  frmPrincipal.lblColorFondo.Enabled = False
  frmPrincipal.txtCantidadDeFotosPorPalabra.Locked = True
  frmPrincipal.txtCantidadDeFotosPorPalabra.BackColor = &H80000000
  frmPrincipal.txtCantidadDePalabras.Locked = True
  frmPrincipal.txtPalabra.PasswordChar = "X"
  frmPrincipal.txtCantidadDePalabras.BackColor = &H80000000
  frmPrincipal.txtPalabra.Locked = True
  frmPrincipal.txtPalabra.BackColor = &H80000000
  frmPrincipal.txtLetras.Locked = True
  frmPrincipal.txtLetras.BackColor = &H80000000
  frmPrincipal.txtImagen.BackColor = &H80000000
  frmPrincipal.cmdEjecutar.Default = True
End If
End Sub


Public Sub OcultarImgenes()
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)

Dim intAux As Integer

For intAux = 1 To intCantidadDeFotos
  frmPantalla.imgImagen(intAux).Visible = False
Next intAux
End Sub


Public Sub MostrarImgenes()
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)

Dim intAux As Integer

For intAux = 1 To intCantidadDeFotos
  frmPantalla.imgImagen(intAux).Visible = True
Next intAux
End Sub

